sub alertmod {
  &LoadLanguage("AlertMod");
  $board = $INFO{'board'};
  $thread = $INFO{'thread'};
  $post = $INFO{'post'};
	$poster = $INFO{'poster'};
	$exmem = $INFO{'exmem'};	
	&BoardTotals("load", $board);
	(undef, undef, undef, undef, undef, undef, undef, undef, $mstate) = split(/\|/, $yyThreadLine);

	#reject access to this subroutine unless the feature is turned on
	if (((${$uid.$currentboard}{'am_status'} ne "1") || (${$uid.$currentboard}{'am_status'} eq "1" && $iamguest && ${$uid.$currentboard}{'am_guest_status'} ne "1")) || ($mstate =~ /l/i && ${$uid.$currentboard}{'am_locked'} ne "1")){
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
  }
	
	#create alert mod input rext area
	$yymain .= qq~
<div class="bordercolor" style="padding: 0px; width: 100%; margin-left: 0px; margin-right: auto;">
  <table width="100%" cellspacing="1" cellpadding="4">
    <tr valign="middle">
      <td align="left" class="titlebg"><img src="$modimgurl/AlertMod/exclamation.gif" alt="" border="0" /> $alertmod{'1'}</td>
    </tr><tr>
		  <td align="left" class="windowbg2">
		    <table width="100%" cellspacing="0" cellpadding="15">
		     <tr>
		        <td align="center" class="windowbg2">$alertmod{'2'}.</td>
				  </tr><tr>
			      <td align="center" class="titlebg" colspan="1"></td>
	        </tr><tr>
					  <form action="$scripturl?action=alertmod2" method="POST">
		        <td align="center" class="windowbg2">
						<textarea name="comment" cols=70 rows=10></textarea>
						<input type="hidden" name="am_security" value="am_security">
						<input type="hidden" name="board" value="$board">
						<input type="hidden" name="thread" value="$thread">
						<input type="hidden" name="post" value="$post">
						<input type="hidden" name="poster" value="$poster">
						<input type="hidden" name="exmem" value="$exmem">
						</td>
				  </tr>
			  </table>
			</td>
		</tr><tr>
			<td align="center" class="titlebg" colspan="2"><input type="submit" value="$alertmod{'3'}">
			</form>
			</td>
		</tr>
	</table>
</div>
~;		
	$yytitle = "$alertmod{'1'}";
	&template;
	exit;
}

sub alertmod2 {
  &LoadLanguage("AlertMod");
  $comment = $FORM{'comment'};
	
	#reject access to this subroutine unless it originated from alertmod
  if (!$FORM{'am_security'}){
		$yySetLocation = qq~$scripturl~;
	  &redirectexit;
	}
  if ($comment eq ""){&fatal_error("$alertmod{'4'}");}
  $board = $FORM{'board'};
  $thread = $FORM{'thread'};
  $post = $FORM{'post'};
	$exmem = $FORM{'exmem'};
 
  #find boardname
	($boardname, undef, undef) = split(/\|/, $board{"$board"});
	&ToChars($boardname);
	
	#open thread to find posters name
	fopen(FILE, "$datadir/$thread.txt");
	@threaddata = <FILE>;
	fclose(FILE);
	($threadtitle, $poster_realname, $p_email, undef, $poster_username, undef, undef, undef, undef, undef, undef, undef, undef) = split(/\|/, $threaddata[$post]);

	#find users screenname
  if (${$uid.$username}{'realname'} eq ""){&LoadUser($username);}
  $realname = ${$uid.$username}{'realname'};

	#open date file and read settings if already set
	fopen(FILE, "<$vardir/alertmod.dat");
	@alertmoddata = <FILE>;
  fclose (FILE);
	chomp @alertmoddata;
	foreach $data(@alertmoddata){
	  ($board_check, undef, undef, undef, undef) = split( /\|/, $data);
		if ($board_check eq $board){
		  $dataline = $data;
		  last;    
		}
	}
	(undef, $old_admins, $old_globals, $old_boardmods, $old_modgroups) = split( /\|/, $dataline);
	(@old_admins) = split(/\,/, $old_admins);
	(@old_globals) = split(/\,/, $old_globals);
	(@old_boardmods) = split(/\,/, $old_boardmods);
	(@old_modgroups) = split(/\,/, $old_modgroups);
	
	#find current admins/globals
	&ManageMemberinfo("load");
	while (($membername, $value) = each(%memberinf)) {
		($memberrealname, undef, $memposition, undef) = split(/\|/, $value);
    if ($memposition eq "Administrator"){push (@admins, $membername);}
		if ($memposition eq "Global Moderator"){push (@globals, $membername);}
	}
	#find current board moderators and modgroup members
	&BoardTotals("load", $board);
  (@boardmods) = split(/\,/, ${$uid.$board}{'mods'});
  (@modgroups) = split(/\,/, ${$uid.$board}{'modgroups'});
	foreach $modgroup(@modgroups){
		$modgroup =~ s/^\s+//;
	  ($mgname, undef, undef, undef, undef, undef, undef, undef, undef, undef) = split(/\|/, $NoPost{"$modgroup"});
		push (@modgroupnames, "$mgname");
	}	
	
##create member send list by checking Alert Mod saved list against current mods/globals/admins
	
	#admins
	@admins = grep /\S/, @admins;
	chomp @admins;
	$count=0;
	while ($admins[$count]){
		foreach $old_admin(@old_admins){
		  chomp $old_admin;
			$old_admin =~ s/^\s+//;
			if($admins[$count] eq $old_admin){push (@sendlist, $old_admin);}
		}
	$count++;
	}
  
	#globals
	@globals = grep /\S/, @globals;
	chomp @globals;
	$count=0;
	while ($globals[$count]){
		foreach $old_global(@old_globals){
		  chomp $old_global;
			$old_global =~ s/^\s+//;
			if($globals[$count] eq $old_global){push (@sendlist, $old_global);}
		}
	$count++;
	}
	
	#board moderators
	@boardmods = grep /\S/, @boardmods;
  chomp @boardmods;
	$count=0;
	while ($boardmods[$count]){
		foreach $old_boardmod(@old_boardmods){
		  chomp $old_boardmod;
			$old_boardmod =~ s/^\s+//;
			$boardmods[$count] =~ s/^\s+//;
			if($boardmods[$count] eq $old_boardmod){push (@sendlist, $old_boardmod);}
		}
	$count++;
	}
	
	#moderator membergroups
	@modgroups = grep /\S/, @modgroups;
	chomp @modgroups;
	$count=0;
	while ($modgroups[$count]){
		foreach $old_modgroup(@old_modgroups){
		  chomp $old_modgroup;
			$old_modgroup =~ s/^\s+//;
			$modgroups[$count] =~ s/^\s+//;
			if($modgroups[$count] eq $old_modgroup){push (@modgroup_sendlist, $old_modgroup);}
		}
	$count++;
	}
	&ManageMemberinfo("load");
	while (($membername, $value) = each(%memberinf)){
	  &LoadUser($membername);
	  foreach $modgroup(@modgroup_sendlist){
		  chomp $modgroup;
		  if (${$uid.$membername}{'position'} eq $modgroup || ${$uid.$membername}{'addgroups'} eq $modgroup){push (@sendlist, $membername);}
		}
	}
	
	#remove duplicate members from send list
	undef %saw;
	@saw{@sendlist} = ();
	@sendlist2 = keys %saw;
	
	#create lists for sending alerts
	foreach $recipient(@sendlist2){
    chomp $recipient;
	  &LoadUser($recipient);
		if (${$uid.$recipient}{'alertmodpref'} eq "email"){push (@emailsendlist, $recipient);}
		elsif (${$uid.$recipient}{'alertmodpref'} eq "im"){push (@imsendlist, $recipient);}
		elsif (${$uid.$recipient}{'alertmodpref'} eq "emailim"){
		  push (@imsendlist, $recipient);
			push (@emailsendlist, $recipient);
		}
	}

  #create instant message
	if (@imsendlist){
	  $alertmessage = "$alertmod{'5'}\n \n";
	  $alertmessage .= "$alertmod{'6'}.\n \n \n";
	  $alertmessage .= "$alertmod{'7'}: [url=$scripturl?board=$board] $boardname [/url]\n";
	  $alertmessage .= "$alertmod{'8'}: [url=$scripturl?num=$thread] $threadtitle [/url]\n";
	  if ($post eq "0"){
	    $alertmessage .= "$alertmod{'9'}: [url=$scripturl?num=$thread#$post] $alertmod{'10'} [/url]\n \n \n";
	  }else{
    	$alertmessage .= "$alertmod{'9'}: [url=$scripturl?num=$thread#$post] $post [/url]\n \n \n";
  	}

	  if ($poster_username eq "Guest"){
      $alertmessage .= "$alertmod{'11'}: $poster_realname\n";
  	}
  	elsif($exmem == 1){
  	  $alertmessage .= "$alertmod{'11'}: $poster_realname($alertmod{'12'})\n";
  	}else{
  	  $alertmessage .= "$alertmod{'11'}: [url=$scripturl?action=viewprofile;username=$poster_username] $poster_realname [/url] \n";
    }
	
  	if ($iamguest){
  	  $alertmessage .= "$alertmod{'13'}.\n \n \n";
  	}else{
	    $alertmessage .= "$alertmod{'14'}: [url=$scripturl?action=viewprofile;username=$username] $realname [/url] \n \n \n";
	  }
	  $alertmessage .= "$alertmod{'15'}:[hr]";
	  $alertmessage .= "[b][i] $comment [/i][/b][hr] \n \n";
	  $alertmessage .= "$alertmod{'16'}: ";
		foreach $recipient(@sendlist2){
		  if (${$uid.$recipient}{'realname'} eq ""){&LoadUser($recipient);}
      $recipientrealname = ${$uid.$recipient}{'realname'};
	    $recipients .= "[url=$scripturl?action=viewprofile;username=$recipient] $recipientrealname [/url],";
  	}
		$recipients =~ s/ //g;
		$recipients =~ s/,/, /g;
  	chop $recipients;
		chop $recipients;
  	$alertmessage .= $recipients;
  	$alertmessage =~ s/\cM//g;
  	$alertmessage =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
  	$alertmessage =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
  	$alertmessage =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
  	&FromChars($alertmessage);
  	&ToHTML($alertmessage);
  	$alertmessage =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
  	$alertmessage =~ s~\n~<br />~g;
  	$alertmessage =~ s/([\000-\x09\x0b\x0c\x0e-\x1f\x7f])/\x0d/g;
  }

 #create email message
	if (@emailsendlist){
	  $emailmessage = qq~$alertmod{'25'} \n \n~;
	  $emailmessage .= qq~$alertmod{'6'}. \n \n \n~;
	  $emailmessage .= qq~$alertmod{'7'}: $boardname \n($alertmod{'17'}: $scripturl?board=$board) \n \n~;
	  $emailmessage .= qq~$alertmod{'8'}: $threadtitle \n($alertmod{'18'}: $scripturl?num=$thread) \n \n~;
	  if ($post eq "0"){
	    $emailmessage .= qq~$alertmod{'9'}: $alertmod{'10'} \n \n \n~;
	  }else{
    	$emailmessage .= qq~$alertmod{'9'}: $post \n \n \n~;
  	}
	  if ($poster_username eq "Guest"){
      $emailmessage .= qq~$alertmod{'11'}: $poster_realname\n~;
  	}
  	elsif($exmem == 1){
  	  $emailmessage .= qq~$alertmod{'11'}: $poster_realname($alertmod{'12'})\n~;
  	}else{
  	  $emailmessage .= qq~$alertmod{'11'}: $poster_realname \n($alertmod{'19'}: $scripturl?action=viewprofile;username=$poster_username)\n \n~;
    }
	
  	if ($iamguest){
  	  $emailmessage .= qq~$alertmod{'20'}. \n \n \n~;
  	}else{
	    $emailmessage .= qq~$alertmod{'14'}: $realname \n($alertmod{'19'}: $scripturl?action=viewprofile;username=$username) \n \n \n~;
	  }
	  $emailmessage .= qq~$alertmod{'15'}: \n \n~;
		$emailmessage .= qq~__________________________________________________________________________ \n~;
	  $emailmessage .= qq~$comment\n~;
		$emailmessage .= qq~__________________________________________________________________________ \n \n~;
	  $emailmessage .= qq~$alertmod{'16'}: ~;
	  foreach $emrecipient(@sendlist2){
		  if (${$uid.$emrecipient}{'realname'} eq ""){&LoadUser($emrecipient);}
      $emrecipientrealname = ${$uid.$emrecipient}{'realname'};
	    $emrecipients .= qq~$emrecipientrealname, ~;
  	}     
	 	chop $emrecipients;
		chop $emrecipients;
   	$emailmessage .= $emrecipients;
  	$emailmessage =~ s/\cM//g;
  	$emailmessage =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
  	$emailmessage =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
  	$emailmessage =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
  	&FromChars($emailmessage);
  	&ToHTML($emailmessage);
  	$emailmessage =~ s/([\000-\x09\x0b\x0c\x0e-\x1f\x7f])/\x0d/g;
  }

	#foreach loop to send alert message via IM
	foreach $mod(@imsendlist){
	  chomp $mod; 
	#create unique message id
	  $messageid = &getnewid;
	  for ($i = 0; $i < $addnr; $i++) { $messageid++; }

	#send instant message to user
  	fopen(INBOX, "$memberdir/$mod.msg");
  	@inmessages = <INBOX>;
  	fclose(INBOX);
  	fopen(INBOX, ">$memberdir/$mod.msg");
  	print INBOX "admin|$alertmod{'21'}|$date|$alertmessage|$messageid|$ENV{'REMOTE_ADDR'}|1\n";
  	print INBOX @inmessages;
  	fclose(INBOX);

	  fopen(IMS, ">$memberdir/$mod.ims");
	  $messages    = $messages + 1;
	  $newmessages = $newmessages + 1;
	  print IMS "\$messages = $messages\;\n\$newmessages = $newmessages\;\n\$outmessages = $outmessages\;\n\$storedmessages = $storedmessages\;\n\n1\;";
	  fclose(IMS);
  }
	
	#foreach loop to send alert message via email
  foreach $mod(@emailsendlist){
    chomp $mod;
	  if (${$uid.$mod}{'realname'} eq ""){&LoadUser($mod);}
    $to = ${$uid.$mod}{'email'};
	  $sub = "$alertmod{'22'}";
    &sendmail($to, $sub, $emailmessage);
	}
	
	$yySetLocation = qq~$scripturl?num=$thread#$post~;
	&redirectexit;
}

1;
