<id>
Alert Moderator YaBB2.1
</id>

<version>
1.04
</version>

<mod info>
Version History:
1.04 : Fixed to remove Alertoption in profile - Option, if user is no more Moderator.
1.03 : Fixed error preventing user option in profile from saving.
1.02 : Corrected the addition of the button by adding to menu'x'.def files - didn't realise I needed to do this at first! SORRY ;-)
1.01 : Made Mod File Compatible With Extended Profiles, also added the LoadLanguage to profile.pl! (And added to AlertMod.lng accordingly!)
1.0  : Intital Release

########################################################
Places an Alert Moderator button onto posts.

An Instant Message or Email will then be sent 
to Admins/Globals/Moderators depending on how
you have the feature set up via the Admin Center. 

Recipients of the reports can choose if they want
an Email, Instant Message or both via their profile
options.
#########################################################


~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
THIS MOD IS COMPATIBLE WITH THE SUB-BOARDS MOD
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Instructions:
-------------
Backup your forum (or at least the below modded files).
 
Apply this mod file using BOARDMOD in the usual way.

Upload the following modified files:
  -AdminIndex.pl
	-Admin/AdminSubList.pl
	-Admin/ModList.pl
	-Sources/Display.pl
	-Sources/Profile.pl
	-Sources/Sublist.pl
	-Sources/System.pl
	-Templates/default/Display.Template
	-Variables/menu0.def
	-Variables/menu0.def
	-Variables/menu0.def
	-Languages/English/menu.lng
	
Upload the new files:
  -Admin/AlertModAdmin.pl in to your Admin folder.
	-Sources/AlertMod.pl in to your Sources folder.
	-Languages/English/AlertMod.lng in to your Languages/English folder.
	
	The modimages should be uploaded to the following folders in your public_html area.
	   (typically something like this: /htdocs/public_html/yabbfiles/)
	-yabbfiles/Buttons/English/alertmod.png
	-yabbfiles/ModImages/AlertMod/exclamation.gif
	
Chmod your files as appropriate.

If you have additional templates, add the <yabb alertmod> tag to the other templates as well.

If your settings fail to save via the Admin Center, upload a blank text file called alertmod.dat
to your Variables folder and chmod accordingly.

You must first visit the Admin Center and set the facility up before it will work.
</mod info>

<author>
Lectrician
</author>

<homepage>
www.askthetrades.co.uk
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$AlertMod = "alertmod_settings|Alert Moderator|Alert Moderator Settings|";
	push (@boardmod_mods, "$AlertMod");
</add before>

<edit file>
Admin/AdminSublist.pl
</edit file>

<search for>
%director=(
</search for>

<add after>
'alertmod_settings',"AlertModAdmin.pl&alertmod_settings",
'alertmod_settings2',"AlertModAdmin.pl&alertmod_settings2",
'alertmod_settings3',"AlertModAdmin.pl&alertmod_settings3",
'alertmod_express_setup',"AlertModAdmin.pl&alertmod_express_setup",
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$AlertMod = "Alert Moderator|Lectrician|This Mod will place an ALERT MODERATOR button on posts.|1.04|September 2nd 2006";
	push (@installed_mods, "$AlertMod");
</add before>

<edit file>
Languages/English/Menu.lng
</edit file>

<search for>
%img_txt =(
</search for>

<add after>
'alertmod' => "Alert Moderator",
</add after>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		my $contactblock    = $contactlist;
</search for>

<add after>
########################## Alert Mod Begin
    if (((${$uid.$annboard}{'am_status'} eq "1" || ${$uid.$currentboard}{'am_status'} eq "1" && !$iamguest) || (${$uid.$currentboard}{'am_status'} eq "1" && $iamguest && ${$uid.$currentboard}{'am_guest_status'} eq "1")) && ($mstate !~ /l/i || ${$uid.$currentboard}{'am_locked'} eq "1")){
			$template_alertmod = qq~$menusep<a href="$scripturl?action=alertmod;board=$currentboard;thread=$viewnum;post=$counter;exmem=$exmem">$img{'alertmod'}</a>~;
		}
########################## Alert Mod End
</add after>

<search for>
		$posthandelblock =~ s/<yabb quote>/$template_quote/g;
</search for>

<add before>
    $posthandelblock =~ s/<yabb alertmod>/$template_alertmod/g;
</add before>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
			else { $drawnldirs .= qq~<option value="$fld">$fld</option>~; }
		}
	}
</search for>

<add after>
	######################## Alert Mod Begin
	my $alertmodchk = &is_moderator($user);
            if(${$uid.$user}{'alertmodpref'} eq "not-assigned" || ${$uid.$user}{'alertmodpref'} eq "" || (!$alertmodchk && ${$uid.$user}{'position'} ne "Administrator" && ${$uid.$user}{'position'} ne "Global Moderator")){
              $alertmodpref = qq~<input type="hidden" name="alertmodpref" value="" />~;
	}else{
	  &LoadLanguage("AlertMod");
	  if(${$uid.$user}{'alertmodpref'} eq "email"){$emailchk = " selected";}
	  if(${$uid.$user}{'alertmodpref'} eq "im"){$imchk = " selected";}
	  if(${$uid.$user}{'alertmodpref'} eq "emailim"){$emailimchk = " selected";}
	  $alertmodpref = qq~
		  </tr>
  		<tr class="windowbg">
		  <td width="320" align="left"><b>$am_profile{'1'}:</b></td>
      <td align="left"><select name="alertmodpref">
			<option value="email" $emailchk>$am_profile{'2'}</option>
			<option value="im" $imchk>$am_profile{'3'}</option>
			<option value="emailim" $emailimchk>$am_profile{'4'}</option>
			</select></td>
      ~;
	}
	######################## Alert Mod End (see also $alertmodpref in $yymain below)
</add after>

<search for>
          <td align="left"><select name="userlanguage">$drawnldirs</select></td>
</search for>

<add after>
          $alertmodpref
</add after>

<search for>
		${$uid.$user}{'timeformat'}    = "$member{'timeformat'}";
</search for>

<add after>
		${$uid.$user}{'alertmodpref'}  = "$member{'alertmodpref'}";
</add after>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
%director=(
</search for>

<add after>
'alertmod',"AlertMod.pl&alertmod",
'alertmod2',"AlertMod.pl&alertmod2",
</add after>

<edit file>
Sources/System.pl
</edit file>

<search for>
			fclose(FORUMTOTALS);
			my @tags = qw(board threadcount messagecount lastposttime lastposter lastpostid lastreply lastsubject lasticon);
</search for>

<add after>
      push(@tags, "am_status", "am_guest_status", "am_locked" , ""); #The empty tag is required in order for the first last of the 3 to be saved - I believe this to be a yabb error in the cnt of tags.
</add after>

<search for>
			seek FORUMTOTALS, 0, 0;
			my @tags = qw(board threadcount messagecount lastposttime lastposter lastpostid lastreply lastsubject lasticon);
</search for>

<add after>
      push(@tags, "am_status", "am_guest_status", "am_locked" , ""); #The empty tag is required in order for the first last of the 3 to be saved - I believe this to be a yabb error in the cnt of tags.
</add after>

<search for>
	# using sequential tag writing as hashes do no sort the way we like them to
	my @tags = qw(password realname email regdate webtitle weburl signature postcount position addgroups icq aim yim gender usertext userpic regtime location bday timeselect timeoffset timeformat hidemail msn gtalk template language lastonline lastpost lastim im_ignorelist im_notify im_popup im_imspop cathide postlayout session sesquest sesanswer favorites dsttimeoffset pageindex);
</search for>

<add after>
	push (@tags, "alertmodpref");
</add after>

<edit file>
Variables/Menu0.def
</edit file>

<search for>
%img = (
</search for>

<add after>
'alertmod' => "<img src=\"$modimgurl/AlertMod/exclamation.$imgext\" alt=\"$img_txt{'alertmod'}\" border=\"0\" /> <span class=\"imgwindowbg\">$img_txt{'alertmod'}</span>",
</add after>

<edit file>
Variables/Menu1.def
</edit file>

<search for>
%img = (
</search for>

<add after>
'alertmod' => "<span class=\"imgwindowbg\">$img_txt{'alertmod'}</span>",
</add after>

<edit file>
Variables/Menu2.def
</edit file>

<search for>
%img = (
</search for>

<add after>
'alertmod' => "<img src=\"$html_root/Buttons/$language/alertmod.$imgext\" alt=\"$img_txt{'alertmod'}\" border=\"0\" />",
</add after>

<edit file>
Templates/default/Display.template
</edit file>

<search for>
$posthandellist = qq~
</search for>

<add after>
	<yabb alertmod>
</add after>